package ch.std.jumpstart;

import org.springframework.boot.CommandLineRunner;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.autoconfigure.domain.EntityScan;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.Profile;
import org.springframework.data.jpa.repository.config.EnableJpaRepositories;

import ch.std.jumpstart.beans.CitiesBean;
import ch.std.jumpstart.jpa.City;
import ch.std.jumpstart.repository.CityRepository;

@SpringBootApplication
@ComponentScan(basePackages = "ch.std.jumpstart")
@EntityScan(basePackages = "ch.std.jumpstart")
@EnableJpaRepositories("ch.std.jumpstart")
public class JumpstartApplication {

	public static void main(String[] args) {
		SpringApplication.run(JumpstartApplication.class, args);
	}

	@Bean
	@Profile("!test")
	public CommandLineRunner setup(CityRepository cityRepository) {
    	return (args) ->  {
    		for (String city: CitiesBean.getCities()) {
    			cityRepository.save(new City(city));
    		}
    	};
	}
}
